import { Container, ModuleOptions, ServiceIdentifiersMap } from 'reactant-di';
import { PreloadedState } from 'redux';
import type { DevOptions, DynamicModules, Loader, ModulesMap, PluginHooks, ReactantStore } from '../interfaces';
interface CreateStoreOptions<T> {
    modules: ModuleOptions[];
    container: Container;
    ServiceIdentifiers: ServiceIdentifiersMap;
    loadedModules: Set<any>;
    load: (...args: Parameters<Loader>) => void;
    dynamicModules: DynamicModules;
    pluginHooks: PluginHooks;
    preloadedState?: PreloadedState<T>;
    devOptions?: DevOptions;
    originalStore?: ReactantStore;
    beforeReplaceReducer?: () => void;
    modulesMap?: ModulesMap;
}
export declare function createStore<T = any>({ modules, container, ServiceIdentifiers, loadedModules, load, dynamicModules, pluginHooks, preloadedState, devOptions, originalStore, beforeReplaceReducer, modulesMap, }: CreateStoreOptions<T>): ReactantStore;
export {};
//# sourceMappingURL=createStore.d.ts.map