import type { FunctionComponent } from 'react';
import type { ReducersMapObject, Middleware, PreloadedState, Reducer, Store } from 'redux';
import { storeKey } from '../constants';
import { Service } from '../interfaces';
declare abstract class PluginModule implements Service {
    readonly [storeKey]?: any;
    /**
     * preloaded state handler for Redux
     */
    preloadedStateHandler?(preloadedState: PreloadedState<any>): PreloadedState<any>;
    /**
     * inject middleware for Redux
     */
    middleware?: Middleware;
    /**
     * inject enhancer for Redux
     */
    enhancer?: Function;
    /**
     * As hook after createStore
     */
    afterCreateStore?(store: Store): Store;
    /**
     * As hook before combine rootReducers
     */
    beforeCombineRootReducers?(reducers: ReducersMapObject): ReducersMapObject;
    /**
     * As hook after combine rootReducers
     */
    afterCombineRootReducers?(rootReducer: Reducer): Reducer;
    /**
     * Define a React Provider for the current PluginModule
     */
    provider?: FunctionComponent<any>;
}
export { PluginModule };
//# sourceMappingURL=plugin.d.ts.map